using DAL.Models.Entities;
using DAL.Models.Filters;
using HRD.WebApi.Repositories;
using Microsoft.EntityFrameworkCore;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace DAL.Repositories
{
    public class WindreamIndexRepository : BaseRepository<WindreamIndex>
    {
        public WindreamIndexRepository(WebApiContext context) : base(context)
        {
        }

        public async Task<List<WindreamIndex>> GetListByFilterAsync(ClientIdFilter filter, bool asNoTracking = true)
        {
            var items = this.RepositoryContext.Set<WindreamIndex>().AsQueryable();

            if (filter.ClientId != null)
            {
                items = items.Where(x => x.ClientId == filter.ClientId);
            }

            return asNoTracking ? await items.AsNoTracking().ToListAsync() : await items.ToListAsync();
        }
    }
}